/*
 * piQa Services Collection
 * Created on Jul 14, 2004
 * Copyright � 2004 - 2008 Ronald D. Grindle
 */
 
package RTObj;

import RTtools.UserSrvcTool;

import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.RsltTable;
import com.qanavigation.DBacc.DBacc2;
import com.qanavigation.QNservices.QNDefs;
import com.qanavigation.QNservices.QNRepBld;
import com.qanavigation.QNservices.SrvltReqTools;
import com.qanavigation.XMLBasics.RsltXMLDoc;
import com.qanavigation.XMLBasics.RsltXMLNode;
import com.qanavigation.XMLBasics.RsltXMLNodeLst;
import com.qanavigation.XMLDB.XMLDB;
import com.qanavigation.XMLDB.XMLDBNode;

/** Builds an CR report.</p>  
 * <p>ProbRepBld isA Rslt.
 * @author RDG
 */
public class CRRepBld extends QNRepBld {
	
	/**
	 * 
	 * @param p_SRT
	 * @param p_FilePath
	 */
	public CRRepBld( DBacc2 p_DBacc, SrvltReqTools p_SRT, String p_FilePath ) {

		super( p_DBacc, p_SRT, p_FilePath, QNDefs.c_NodeCRReport );
				
		if( notOK() ) {
			
			addRsltAddInfo( "'CRRepBld.CRRepBld(..)' failed." );
		}
	}
	
	/**
	 * 
	 * @param p_xDB
	 * @param p_SRT
	 * @param p_FilePath
	 */
	public CRRepBld( XMLDB p_xDB, SrvltReqTools p_SRT, String p_FilePath ) {

		super( p_xDB, p_SRT, p_FilePath, QNDefs.c_NodeCRReport );
				
		if( notOK() ) {
			
			addRsltAddInfo( "'CRRepBld.CRRepBld( XMLDB..)' failed." );
		}
	}	

	/**
	 * Saves to DB and appends UID to TC Execution, if coming from execution.
	 * Appends files to report, if necessary.
	 * @param p_Author
	 * @param p_IsDraft
	 * @param p_wTicket
	 * @return
	 */
	public RsltString save2DB( String p_Author, boolean p_IsDraft, boolean p_wTicket ) {
		
		RsltString UID;
		
		UID = super.save2DB( p_Author, p_IsDraft, p_wTicket );
		
		return UID;
	}

	/**
	 * 
	 * @param p_UID
	 * @param p_prUID
	 * @param p_ticket
	 * @param p_title
	 * @param p_stat
	 * @return
	 */
	public RsltString addPR( String p_UID, String p_prUID, String p_ticket, String p_title, String p_stat ) {
		
		RsltString res;
		
		RsltXMLNode xNode;
		
		xNode = bldRefProbRepNode( p_prUID, p_ticket, p_title, p_stat );
		
		res = m_xDB.appSubTree( p_UID, xNode, true );
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "CRRepBld.addPR(..) failed." );
		}
		
		return res;
	}
	
	/**
	 * @param p_IsDraft
	 */
	public Rslt bldCRRep( boolean p_IsDraft, boolean p_IsSub ) {
		
		boolean bTolerant = false;
		
		int i, x;
		
		Rslt res = new Rslt( true );
		Rslt aRes;
		RsltString rVal;
		
		RsltXMLNode aNode;
		
		String count;
		String aUID;
		String aTicket;
		String aTitle;
		String aStat;		
		String aVal;	

		/*
<!ELEMENT ChgReq ( AppFile*, Cmnt?, Desc, ExtSystms?, LogEntry*, ProcLog*, RefProbRep* )>
	<!ATTLIST ChgReq
		Appl				CDATA #IMPLIED
		Assignd			CDATA #IMPLIED
		Author			CDATA #IMPLIED
		ContctBA		NMTOKEN #IMPLIED
		CostBA			NMTOKEN #IMPLIED
		CostBAFac, CostBAOver NMTOKEN #IMPLIED
		CostImp			NMTOKEN #IMPLIED
		CostImpFac, CostImpOver NMTOKEN #IMPLIED
		CostTotal		NMTOKEN #IMPLIED
		CRProcStat					(list) 
		CRStat							(list) 
		DateTime		NMTOKEN #REQUIRED
		DlvDate			NMTOKEN #IMPLIED
		EstDate			NMTOKEN #IMPLIED
		ExtDateTime NMTOKEN #IMPLIED
		ExtDocID		NMTOKEN #IMPLIED
		ExtID			NMTOKEN #IMPLIED
		ExtPRID			NMTOKEN #IMPLIED
		ExtPRSrc	NMTOKEN #IMPLIED		
		ExtSource		CDATA #IMPLIED
		ExtStat			CDATA #IMPLIED
		ExtSysFlags NMTOKEN #IMPLIED
		LastMod			NMTOKEN #IMPLIED
		LastModBy		CDATA #IMPLIED
		Lock				NMTOKEN #IMPLIED
		OrderDate		NMTOKEN #IMPLIED
		Prio				NMTOKEN #IMPLIED
		Reqstr			CDATA #IMPLIED
		RiskFac, RiscOver NMTOKEN #IMPLIED
		SoftRel			CDATA #IMPLIED
		Ticket			NMTOKEN #IMPLIED
		Title				CDATA #REQUIRED
		TrgtEstDate NMTOKEN #IMPLIED
		TrgtImpDate NMTOKEN #IMPLIED
		Type				NMTOKEN #IMPLIED
		UID					NMTOKEN #IMPLIED
	>

	<!ELEMENT ExtSystms (#PCDATA)>
		<!ATTLIST ExtSystms
			UID			NMTOKEN #IMPLIED
		>
		 */

		try {
			
			if( p_IsDraft ) {
				
				bTolerant = true;
				
//addRsltAddInfo( "bTolerant: " + bTolerant);				
			}
			
			m_xDoc = new RsltXMLDoc( "", QNDefs.c_NodeCRReport, QNDefs.c_CRRepDTD, null );
			
			if(	res.checkRslt( m_xDoc ) ) {
				
				RsltXMLNode tNode = m_xDoc.getTopNode();
				
				if( p_IsDraft ) {
					
					appAttr( tNode, "Author", QNDefs.c_AttrAssignd, false );
				}
				else if( p_IsSub ){
					
					UserSrvcTool ut = new UserSrvcTool( m_xDB );
					
					rVal = ut.getAss4NewCR();
					
					if( res.checkRslt( rVal ) ) {
						
						tNode.addAttribute( QNDefs.c_AttrAssignd, rVal.getString() );	
					}
					else {
						
						res.addRsltAddInfo( "Failed to identify supervisor." );					
					}
				}
				else {
					
					appAttr( tNode, QNDefs.c_AttrAssignd, false );
				}				
				
				res.checkRslt( tNode );
				
				res.checkRslt( m_SRT );
	
				//checkRslt( tNode );
				
				appAttr( tNode, "Appl", true );
				appAttr( tNode, "AffSys", true );
				appAttr( tNode, "Author", false );
				appAttr( tNode, "ContctBA", true );
				appAttr( tNode, "ContctImp", true );				
				appAttr( tNode, "CostBA", true );
				appAttr( tNode, "CostBAOver", true );
				appAttr( tNode, "CostImp", true );
				appAttr( tNode, "CostImpOver", true );
				appAttr( tNode, "CostTotal", true );
				appAttr( tNode, "CRProcStat", true );
				appAttr( tNode, "CRStat", true );
				appAttr( tNode, "DateTime", true );
				appAttr( tNode, "DlvDate", true );
				appAttr( tNode, "EstDate", true );
				appAttr( tNode, "ExtDateTime", true );
				appAttr( tNode, "ExtDocID", true );
				appAttr( tNode, "ExtID", true );
				appAttr( tNode, "ExtPRID", true );
				appAttr( tNode, "ExtPRSrc", true );
				appAttr( tNode, "ExtSource", true );
				appAttr( tNode, "ExtStat", true );
				appAttr( tNode, "ExtSysFlags", true );
				appAttr( tNode, "LastMod", true );
				appAttr( tNode, "LastModBy", true );
				appAttr( tNode, "Lock", true );
				appAttr( tNode, "OrderDate", true );
				appAttr( tNode, "Prio", true );
				appAttr( tNode, "Reqstr", true );
				appAttr( tNode, "RelPlan", true );
				appAttr( tNode, "RelAct", true );				
				appAttr( tNode, "RiscOver", true );
				appAttr( tNode, "SoftRel", true );
				appAttr( tNode, "Ticket", true );
				
//rVal = m_SRT.getVal( "Title" );
//System.out.println( "CR Title '" + rVal.getString() + "'" );	

				appAttr( tNode, "Title", false );				
				appAttr( tNode, "TrgtEstDate", true );
				appAttr( tNode, "TrgtImpDate", true );
				appAttr( tNode, "Type", true );

				rVal = m_SRT.getVal( "UID" );
				
				if( rVal.getString().length() > 0 ) {
					
					tNode.addAttribute( "UID", rVal.getString() );
					
					//addRsltAddInfo( "UID added: " + rVal.getString() );
				}				
				
				appTxtNode( tNode, "Desc", true );
				appTxtNode( tNode, "Cmnt", true );
				appTxtNode( tNode, "ExtSystms", true );
				
				// List of ExtTRs referenced
				count = m_SRT.getStrVal( "ExtTRCount" );

				x = Integer.parseInt( count );

				for( i = 0; i < x; ++i ) {
					
					aVal = m_SRT.getStrVal( "ExtTRID" + i );

					if( aVal.length() > 0 ) {
				
						aNode = tNode.appNode( "ExtTR" );
						
						aNode.addAttribute( QNDefs.c_AttrExtID, aVal );
						
						aVal = m_SRT.getStrVal( "ExtTRSrc" + i );
						aNode.addAttrAsHTML( QNDefs.c_AttrExtSrc, aVal );
						
						aTitle = m_SRT.getStrVal( "ExtTRTitle" + i );
						aNode.addAttrAsHTML( QNDefs.c_AttrTitle, aTitle );
					}
				}				
				
				// List of PR attached
				count = m_SRT.getStrVal( "PRCount" );

				x = Integer.parseInt( count );

				for( i = 0; i < x; ++i ) {
					
					aUID = m_SRT.getStrVal( "PRUID" + i );

					if( aUID.length() > 0 ) {
				
						aTicket = m_SRT.getStrVal( "PRTicket" + i );	
						aTitle = m_SRT.getStrVal( "PRTitle" + i );
						aStat = m_SRT.getStrVal( "PRStat" + i );

						aNode = tNode.appNode( "RefProbRep" );
						
						aNode.addAttribute( QNDefs.c_AttrRefUID, aUID );
						aNode.addAttribute( QNDefs.c_AttrTicket, aTicket );
						aNode.addAttrAsHTML( QNDefs.c_AttrTitle, aTitle );
						aNode.addAttribute( QNDefs.c_AttrProbStat, aStat );
					}
				}
			
				aRes = appExistFiles( tNode );
				
				if( aRes.isOK( true ) ) {
				
					aRes = appExistLogs( tNode );					
				}
			
/*			
aNode = tNode.appNode( QNDefs.c_NodeLogEntry );
aNode.appTxt( "Isdraft " + p_IsDraft + " IsSub " + p_IsSub + " " + msg );
*/
				if( aRes.isOK( true ) ) {
					
//					m_IsLoaded = true;
				}
				else {
					
					res.setRsltStat( aRes );
				}
			}
		}
		catch( Exception excp ) {
			
			res.setRsltByExcp( excp );
		}
		
		if( res.notOK() ) {

			res.addRsltAddInfo( "'CRRepBld.bldProbRep(..)' failed." );
		}
		else {
			
			m_XDocIsInit = true;
		}
		
		checkRslt( res );
		
		return res;
	}	
	
	// ----------------------------------
	protected RsltXMLNode bldRefProbRepNode( String p_prUID, String p_ticket, String p_title, String p_stat ) {
	
		RsltXMLNode xNode = new RsltXMLNode( QNDefs.c_NodeRefProbRep );
	
	/*		<!ELEMENT RefProbRep (EMPTY)>
			<!ATTLIST RefProbRep
				RefUID	NMTOKEN #REQUIRED
				Ticket	NMTOKEN #IMPLIED
				Title		CDATA #REQUIRED
				ProbStat	NMTOKEN #IMPLIED
				UID			NMTOKEN #IMPLIED
			> */
			
		xNode.addAttribute( QNDefs.c_AttrRefUID, p_prUID );
		xNode.addAttribute( QNDefs.c_AttrTicket, p_ticket );
		xNode.addAttrAsHTML( QNDefs.c_AttrTitle, p_title );
		xNode.addAttribute( QNDefs.c_AttrProbStat, p_stat );
		
		return xNode;
	}
	
	/**
	 * 
	 * @param p_UID
	 * @return
	 */
	public Rslt loadCRData( String p_UID ) {
		
		int i, x;
		
		Rslt res = new Rslt( true );
		RsltString val;
		RsltTable attrs;
		
		RsltXMLNode aNode;
		RsltXMLNodeLst rNLst;
		
		XMLDBNode xNode;
		
		xNode = m_xDB.getXMLsubTree( p_UID );
		
		if( res.checkRslt( xNode ) ) {
			
			m_xDoc = xNode.m_RxDoc;
			
			attrs = m_xDB.getNodeAttrs( p_UID );
			
			if( res.checkRslt( attrs ) ) {
				
				m_SRT.add2ParamLst( attrs );
			}
	
			val = xNode.getSubNodeVal( "Desc" );

			m_SRT.add2ParamLst( "Desc", val.getString() );			
			
			val = xNode.getSubNodeVal( "Cmnt" );

			m_SRT.add2ParamLst( "Cmnt", val.getString() );

			val = xNode.getSubNodeVal( "ExtSystms" );

			m_SRT.add2ParamLst( "ExtSystms", val.getString() );
			
			// Attached Problem Reports
			rNLst = xNode.getSubNodes( "ExtTR" );
			
			x = rNLst.size();
			
			m_SRT.add2ParamLst( "ExtTRCount", String.valueOf( x ) );
			
			for( i = 0; i < x; ++i ) {
				
				aNode = rNLst.getNode( i );				
				
				val = aNode.getAttrVal( QNDefs.c_AttrExtID );
				
				m_SRT.add2ParamLst( "ExtTRID" + i , val.getString() );				
				
				val = aNode.getAttrVal( QNDefs.c_AttrExtSrc );
				
				m_SRT.add2ParamLst( "ExtTRSrc" + i , val.getString() );
				
				val = aNode.getAttrVal( QNDefs.c_AttrTitle );
				
				m_SRT.add2ParamLst( "ExtTRTitle" + i , val.getString() );
			}
			
			// Attached Problem Reports
			rNLst = xNode.getSubNodes( "RefProbRep" );
			
			x = rNLst.size();
			
			m_SRT.add2ParamLst( "PRCount", String.valueOf( x ) );
			
			for( i = 0; i < x; ++i ) {
				
				aNode = rNLst.getNode( i );				
				
				val = aNode.getAttrVal( QNDefs.c_AttrRefUID );
				
				m_SRT.add2ParamLst( "PRUID" + i , val.getString() );
				
				val = getDocStat( val.getString(), QNDefs.c_AttrProbStat );
				
				/* val = aNode.getAttrVal( QNDefs.c_AttrProbStat );	*/
				
				m_SRT.add2ParamLst( "PRStat" + i , val.getString() );
				
				val = aNode.getAttrVal( QNDefs.c_AttrTicket );
				
				m_SRT.add2ParamLst( "PRTicket" + i , val.getString() );
				
				val = aNode.getAttrVal( QNDefs.c_AttrTitle );
				
				m_SRT.add2ParamLst( "PRTitle" + i , val.getString() );
			}
		
			if( res.isOK( true ) ) {
				
				m_XDocIsInit = true;
			}
		}
		
		if( res.isOK() ) {

			res.addRsltAddInfo( "'ProbRepBld.loadPRData(..)' failed." );
		}
		
		return res;
	}
	
}
