/*
 * Created on 31.01.2008
 *
 * Copyright � 2008 Ronald D. Grindle
 */
package RTObj;

import com.qanavigation.Basics.BTools;
import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.DBacc.DBacc2;
import com.qanavigation.QNservices.QNDefs;
import com.qanavigation.QNservices.QNRef2File;
import com.qanavigation.QNservices.QNRef2FileLst;
import com.qanavigation.QNservices.QNRepBld;
import com.qanavigation.QNservices.SrvltReqTools;
import com.qanavigation.XMLBasics.RsltXMLDoc;
import com.qanavigation.XMLBasics.RsltXMLNode;

// ###############################
public class ExecRepBld extends QNRepBld {
	
	private String m_DT = "";
	private String m_ElapTime = "";
	private String m_ExCode = "";
	private String m_CTCUID = "";
	
	// -----------------------------------------
	/**
	 * 
	 * @param p_SRT
	 * @param p_FilePath
	 */
	public ExecRepBld( DBacc2 p_DBacc, SrvltReqTools p_SRT, String p_FilePath ) {

		super( p_DBacc, p_SRT, p_FilePath, QNDefs.c_NodeTCExec );
		
		if( notOK() ) {
			
			addRsltAddInfo( "'ExecRepBld.ExecRepBld(..)' failed." );
		}		
	}
	
	// -----------------------
	private Rslt appCTCEx( String p_UIDTCEx ) {

		Rslt res = new Rslt( true );
		RsltXMLNode RTCExNode;

		/*
			<!ELEMENT RefTCExec (EMPTY)>
				<!ATTLIST RefTCExec
					DateTime	NMTOKEN #REQUIRED
					ExCode		(er|ok) ""
					ExcDur		NMTOKEN #IMPLIED
					RefUID		NMTOKEN #REQUIRED
					UID				NMTOKEN #IMPLIED
				>
		*/
		
		if( m_CTCUID.length() > 0 ) {

			RTCExNode = new RsltXMLNode( "RefTCExec" );
	
			// obsolete? RTCExNode.addUID( m_uidRTCEx );
	
			if( RTCExNode.isOK() ) {
	
				RTCExNode.addAttribute( "DateTime", m_DT );
	
				RTCExNode.addAttribute( "ExCode", m_ExCode );
	
				RTCExNode.addAttribute( "ExcDur", m_ElapTime );
	
				RTCExNode.addAttribute( "RefUID", p_UIDTCEx );
	
				res = m_xDB.appSubTree( m_CTCUID, RTCExNode, true );	
			}
			
			res.checkRslt( RTCExNode );
		}
		
		return res;
	}
	
	// -------------------------------------
	/**
	 * Build an Test Execution Report
	 *
	 */
	public void bldExecRep() {

		RsltString rVal;
		
		String tcUID;
		String cmpgnUID;
		
		/*
			<!ELEMENT TCExec ( TstSysRef, Comment?, RefProbRep*, ProcLog* ) >
				<!ATTLIST TCExec
					Appl			CDATA #IMPLIED
					Author		CDATA	#IMPLIED
					Cmpgn			CDATA #IMPLIED
					CmpgnUID	NMTOKEN #IMPLIED
					DateTime	NMTOKEN #REQUIRED
					ExcDur		NMTOKEN #IMPLIED
					ExCode		(er|ip|ok) "er"
					Fctn			CDATA #IMPLIED
					LastMod		NMTOKEN #IMPLIED
					LastModBy	CDATA #IMPLIED
					Lock			NMTOKEN #IMPLIED
					Section		CDATA #IMPLIED
					SeqNum		CDATA	#IMPLIED
					SoftRel		NMTOKEN #IMPLIED
					TCUID			NMTOKEN #REQUIRED
					Title			CDATA #REQUIRED
					UID				NMTOKEN #IMPLIED
				>
			
				<!ELEMENT Comment (#PCDATA)>
					<!ATTLIST Comment
						UID			NMTOKEN #IMPLIED
					>
		*/
		
		try {
					
			m_xDoc = new RsltXMLDoc( "", QNDefs.c_NodeTCExec, QNDefs.c_TCExecDTD, null );
			
			if(	checkRslt( m_xDoc ) ) {
				
				rVal = m_SRT.getVal( "TCUID" );
				
				tcUID = rVal.getString();
				
				rVal = m_SRT.getVal( "CmpgnUID" );
				
				cmpgnUID = rVal.getString();
				
				if( cmpgnUID.length() > 0 ) {
					
					m_CTCUID = tcUID;
					
					rVal = m_xDB.getAttrVal( tcUID, "RefUID" );
					
					tcUID = rVal.getString();
				}
				
				RsltXMLNode tNode = m_xDoc.getTopNode();
				
				appAttrRetr( tNode, "Appl", "Appl", "Appl", tcUID );
										
				appAttr( tNode, "Author", true );
				
				if( cmpgnUID.length() > 0 ) {
				
					appAttrRetr( tNode, "Cmpgn", "Cmpgn", "Title", cmpgnUID );
					
					tNode.addAttribute( "CmpgnUID", cmpgnUID );
				}

				//appDateTime( tNode, "Date", "Time", "DateTime", true );
				rVal = m_SRT.getVal( "DateTime" );
				
				if( rVal.getString().length() < 1 ) {
					
					rVal.setString( BTools.getNowISODateTimeSec() );				
				}
				
				m_DT = rVal.getString();
				
				tNode.addAttribute( "DateTime", m_DT );
				
				rVal = m_SRT.getVal( "ExcDur" );
				
				m_ElapTime = rVal.getString();
				
				tNode.addAttribute( "ExcDur", m_ElapTime );
				
				rVal = m_SRT.getVal( "ExCode" );
				
				m_ExCode = rVal.getString();
				
				tNode.addAttribute( "ExCode", m_ExCode );				

				appAttrRetr( tNode, "Fctn", "Fctn", "Fctn", tcUID );

				appAttrRetr( tNode, "Section", "Section", "Section", tcUID );
				
				appAttr( tNode, "SeqNum", true );		
				
				appAttr( tNode, "SoftRel", true );
				
				tNode.addAttribute( "TCUID", tcUID );
				
				appAttrRetr( tNode, "Title", "Title", "Title", tcUID );
				
				rVal = m_SRT.getVal( "UID" );
				
				if( rVal.getString().length() > 0 ) {
					
					tNode.addAttribute( "UID", rVal.getString() );
					
					//addRsltAddInfo( "UID added: " + rVal.getString() );
				}		
				
				/* <!ELEMENT TstSysRef (#PCDATA)>
				<!ATTLIST TstSysRef
					RefUID	NMTOKEN #IMPLIED
					Title		CDATA #IMPLIED
					UID			NMTOKEN #IMPLIED
				> */
				
				//appTxtNode( tNode, "TstSysRef", true );
				
				/* <!ELEMENT Comment (#PCDATA)>
				<!ATTLIST Comment
					UID			NMTOKEN #IMPLIED
				> */
			
				appTxtNode( tNode, "Comment", true );
				
				/*<!ELEMENT ProcLog (#PCDATA)>
					<!ATTLIST ProcLog
						DateTime	NMTOKEN #REQUIRED
						Type			(ad|ed) "ad"
						UID				NMTOKEN #IMPLIED
					>*/
				
				rVal = m_SRT.getVal( "FName" );
				
				if( rVal.getString().length() > 0 ) {
					
					String fName = rVal.getString();
					
					rVal = m_SRT.getVal( "FTitle" );
					String fTitle = rVal.getString();					
					
					rVal = m_SRT.getVal( "Fdt" );
					String fDT = rVal.getString();	
					
					QNRef2FileLst r2fLst = new QNRef2FileLst( "TestRsltData" );
					
					QNRef2File r2f = new QNRef2File( fTitle, "", "", fDT, fName );
					
					r2fLst.add( r2f );
					
					r2fLst.loadYSUp( tNode );
			
				}				
			}
		}
		catch( Exception excp ) {
			
			setRsltByExcp( excp );
		}
		
		if( notOK() ) {

			addRsltAddInfo( "'ExecRepBld.bldExecRep(..)' failed." );
		}
		else {
			
			m_XDocIsInit = true;
		}
	}	
	
	/**
	 * Save document to the database.
	 * @return
	 */
	public RsltString save2DB( ) {
		
		Rslt res;
		RsltString UID = new RsltString( true );

		try {
			
			if( !m_XDocIsInit ) {

				UID.setInError( "m_xDoc not init." );
			}
			else {
				
				// not yet required
				// res = storeFile( m_xDoc.getTopNode(), "FileDesc" );
				
				//if( UID.checkRslt( res, true ) ) {
					
				UID = super.save2DB( m_xDoc );
				
				if( UID.isOK() ) {
				
					res = appCTCEx( UID.getString() );
					
					UID.checkRslt( res );
				}
				//}
			}
		}
		catch( Exception excp ) {
			
			UID.setRsltByExcp( excp );
		}
		
		if( !checkRslt( UID ) ) {

			addRsltAddInfo( "'ExecRepBld.save2DB(..)' failed." );
		}
				
		return UID;
	}
	
}
