//---------------------------------------------------------
// Copyright  2003 - 2009 Ronald D. Grindle
//---------------------------------------------------------

package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNRscBundle;
import com.qanavigation.QNservices.QNconfig;
import com.qanavigation.QNservices.SrvltReqTools;
import com.qanavigation.XMLDB.XMLDB;

/**
 *  Base Object for RT Interfaces
 * @author RGDM2
 *
 */
public class RTIFObj extends Rslt {
	
	public HttpServletRequest m_Request;
	
	public QNDBacc2 m_dBAcc;
	public QNRscBundle m_resBndl;
	public QNconfig m_qConf;
	
	public SrvltReqTools m_sTools;
	
	public String m_User;
	
	public XMLDB m_xDB;
	
	/**
	 * 
	 * @param p_Request
	 * @param p_dBAcc
	 *
	public RTIFObj( HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {
		
		super( true );
		
		m_xDB = new XMLDB(  )
		
		initMe( p_Request, p_dBAcc );

//addRsltAddInfo( "PTIFObj.PTIFObj(2)" );		
	}*/
	
	/**
	 * 
	 * @param p_Request
	 * @param p_dBAcc
	 * @param p_xDB
	 */
	public RTIFObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {
		
		super( true );
		
		initMe( p_Srvl, p_Request, p_dBAcc );

		if( notOK() ) {
			
			addRsltAddFailInfo( "RTIFObj", "RTIFObj", "", "" );
		}	
	}
	
	// ------------------
	private void initMe( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {
		
		m_Request = p_Request;
		
		m_dBAcc = p_dBAcc;
		
		if( checkRslt( m_dBAcc ) ) {
			
			m_qConf = new QNconfig();
			
			if( checkRslt( m_qConf ) ) {
					
				RsltString uSrv = m_qConf.getUIDsrvHostName();
				
				if( checkRslt( uSrv ) ) {
				
					m_xDB = new XMLDB( p_dBAcc.m_DB, uSrv.getString() );
					
					checkRslt( m_xDB );
				}
			}			
			
			m_resBndl = new QNRscBundle( "QNLabels", p_Request.getLocale() );
			
			m_sTools = new SrvltReqTools( p_Srvl, p_Request );
			
			m_User = p_Request.getRemoteUser();	
		}
		
//addRsltAddInfo( "PTIFObj.initMe()" );
	}
}
