// QANav Report Tracker Copyright 2008 -2009 Ronald D. Grindle

package RTObj;

import java.util.ArrayList;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import com.qanavigation.Basics.BTools;
import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.RsltTable;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;
import com.qanavigation.QNservices.QNRepBld;

/**
 * RT Report Edit Base Object
 * @author RGDM2
 *
 */
public class RTRepObj extends RTtoolsObj {
	
	public boolean m_statIsDraft = false;
	
	public boolean m_modeIsDel;
	public boolean m_modeIsEdit;
	public boolean m_modeIsEdit2;
	public boolean m_modeIsUpl;
	
	public boolean m_isHandled = false;
	
	public RsltString m_UID = new RsltString();
	
	public QNRepBld m_RepBld;

	public String m_RepStat;
	public String m_RepJSP = "";
	
	public String m_cRo;
	public String m_ro;
	
	// --------------------------
	protected RTRepObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {

		super( p_Srvl, p_Request, p_dBAcc );
		
		initMe();
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "RTRepObj", "RTRepObj", "", "" );
		}		
	}
	
	/**
	 * 
	 * @param p_StatName
	 * @return
	 */
	public String getRepStat( String p_StatName ) {	
		
		String repStat = "dr";
		
		RsltString res;
		String UID;
		
		UID = m_UID.getString();
		
		if( UID.length() > 0 ) {
			
			res = m_xDB.getAttrVal( UID, p_StatName );
			
			if( res.isOK() ) {
			
				repStat = res.getString();
			}
		}
		
		return repStat;
	}
	
	/**
	 * That's bull, dump it asap, use getDateTime
	 * @return
	 */
	public String getDate() {
		
		String str;
		
		if( !( m_modeIsUpl || m_modeIsDel) ) {
	
			str = BTools.getNowISODate();
		}
		else {
	
			str = m_RepBld.getVal( "Date" );
		}
		
		return str;
	}
	
	/**
	 * 
	 * @return
	 */
	public String getDateTime() {
		
		String str;
		
		str = m_RepBld.getVal( "DateTime" );
		
		if( str.length() < 1 ) {
	
			str = BTools.getNowISODateTimeSec();
		}
		
		return str;
	}
	
	/**
	 * 
	 * @return
	 */
	public ArrayList<String> getFileRows() {
		
		ArrayList<String> outLst = new ArrayList<String>();
		
		int i, x;
		
		RsltTable fileTbl;
		
		String str;
		String[] row;
		
		fileTbl = m_RepBld.getAppFileData();
	
		if( fileTbl.isOK() ) {
			
			x = fileTbl.getRowNum();
		
			String p1 = "<tr><td valign=\"center\" align=\"left\" width=\"550pt\"><p><a href=\"" + QNDefs.c_RMFilePath + "/";
			// uid
			//String p2 = "\" type=\"application/octet-stream\">";
			String p2 = "\" type=\"";
			// file type
			String p3 = "\" target=\"_blank\">";
			//String p3 = "\" >";
			// file name
			String p4 = "</a></p><p>" + m_resBndl.getString( "lblDesc" ) + ":</p><input class=\"ro\" type=\"text\" size=\"82\" value=\"";
			// desc
			String p5 = "\" readonly/></td><td valign=\"center\" align=\"middle\"><input type=\"button\" style=\"width:120px\" onclick=\"doDelete('";
			// uid
			String p6 = "', '";
			// file name
			String p7 = "', '" + m_RepJSP + "');\" value=\"" + m_resBndl.getString( "blblDel" ) + "\"/></td></tr>";
		
			for( i = 0; i < x; ++i ) {
		
				row = fileTbl.getRow( i );
		
				str = p1 + row[0] + "/" + row[5] + p2 + row[1] + p3 + row[3] + p4 + row[6] + p5 + row[0] + p6 + row[3] + p7;
		
				outLst.add( str );
			}
		}
		
		return outLst;
	}

	/**
	 * 
	 * @return
	 */
	public RsltString getTicket() {
		
		String sVal;
	
		RsltString rVal;
		
		sVal = m_RepBld.getVal( "Ticket" );
	
		if( sVal.length() > 0 ) {
			
			rVal = new RsltString();
			
			rVal.setString( sVal );
		}
		else {
			
			rVal = m_dBAcc.m_DB.getIncrCounter( "Counters", "PRCount" );
		}
		
		return rVal;
	}
	
	/**
	 *  That's bull, dump it asap, use getDateTime
	 * @return
	 */
	public String getTime() {
		
		String str;
		
		if( !( m_modeIsUpl || m_modeIsDel) ) {
	
			str = BTools.getNowISOTime();
		}
		else {
	
			str = m_RepBld.getVal( "Time" );
		}
		
		return str;
	}
	
	// ------------------
	protected Rslt handleDelFile( ) {
		
		Rslt res = new Rslt( true );
		
		RsltString fileUID;
		RsltString fileName;
		
		fileName = m_sTools.getVal( "DelName" );
		fileUID = m_sTools.getVal( "DelUID" );
	
		res = m_RepBld.deleteFile( fileUID.getString() );					
			
		if( res.notOK() ) {

			res.addRsltAddInfo( "Failed to remove file '" + fileName.getString() + "' (" + fileUID.getString() + ")." );
		}
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "RTRepObj.handleDelFile() failed." );
		}
		
		return res;
	}
	
	// --------------------------	
	private void initMe( ) {
		
		m_isHandled = false;
		
		m_modeIsUpl = false;
		m_modeIsDel = false;
		m_modeIsEdit = false;
		
		m_cRo = "";
		m_ro = "";	
		
		m_RepStat = "dr";
		
//addRsltAddInfo( "RTRepObj.initMe()" );			
	}

	// --------------------------	
	protected void init( QNRepBld p_RepBld, String p_RepJSP ) {
		
		m_RepBld = p_RepBld;
		m_RepJSP = p_RepJSP;
	}
}
