// QANav Report Tracker Copyright 2008 -2009 Ronald D. Grindle

package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;

/**
 * Technical Report List Base Object
 * @author RGDM2
 *
 */
public class ShpLstObj extends RTLstLstObj {
		
	public boolean m_roleIsShpSup = false;
	public boolean m_roleIsShpSrvc = false;
	
	// -------------------------
	public ShpLstObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {
		
		super( p_Srvl, p_Request, p_dBAcc );
		
		initMe();
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "ShpLstObj", "ShpLstObj", "", "" );
		}
	}
	
	// -------------------------
	private void initMe() {

		m_roleIsShpSup = m_uRTool.isShpSuper();
		m_roleIsShpSrvc = m_uRTool.isShpSrvc();
		m_roleIsSrvc = m_roleIsShpSrvc;	
	}
	
	// --------------------------
	public void  prepare() {
		
		prepParam( QNDefs.c_AttrAssignd, "", "false" );
		prepParam( QNDefs.c_AttrAuthor, "", "false" );
		prepParam( QNDefs.c_AttrCmnt, "", "false" );
		prepParam( QNDefs.c_AttrDateTime, "CmpDateTime", "false" );
		prepParam( QNDefs.c_AttrAppl, "", "false" );
		prepParam( QNDefs.c_AttrShpStat, "", "false" );
		prepParam( QNDefs.c_AttrShipRel, "CmpShipRel", "false" );
		prepParam( QNDefs.c_AttrDateTimeShip, "CmpDateTimeShip", "false" );
		
		if( m_roleIsShpSrvc ) {
			
			if( m_modeIsAll ) {
			
				m_assGroup = "";
			}
			else {
	
				if( !( m_roleIsShpSup ) ) { 
	
					m_uGroup = m_yGroup;
				}
			}
		}
		else {
	
			m_paramMap.put( "Author", m_User );
			m_strRO = " readonly";
		}		
	}
}
