﻿<?xml version='1.0'?>
<!-- Stylesheet for a Technical Report -->

<!DOCTYPE stylesheet [

<!ENTITY nbsp    "&#160;" >
<!ENTITY iexcl   "&#161;" >
<!ENTITY cent    "&#162;" >
<!ENTITY pound   "&#163;" >
<!ENTITY curren  "&#164;" >
<!ENTITY yen     "&#165;" >
<!ENTITY brvbar  "&#166;" >
<!ENTITY sect    "&#167;" >
<!ENTITY uml     "&#168;" >
<!ENTITY copy    "&#169;" >
<!ENTITY ordf    "&#170;" >
<!ENTITY laquo   "&#171;" >
<!ENTITY not     "&#172;" >
<!ENTITY shy     "&#173;" >
<!ENTITY reg     "&#174;" >
<!ENTITY macr    "&#175;" >
<!ENTITY deg     "&#176;" >
<!ENTITY plusmn  "&#177;" >
<!ENTITY sup2    "&#178;" >
<!ENTITY sup3    "&#179;" >
<!ENTITY acute   "&#180;" >
<!ENTITY micro   "&#181;" >
<!ENTITY para    "&#182;" >
<!ENTITY middot  "&#183;" >
<!ENTITY cedil   "&#184;" >
<!ENTITY sup1    "&#185;" >
<!ENTITY ordm    "&#186;" >
<!ENTITY raquo   "&#187;" >
<!ENTITY frac14  "&#188;" >
<!ENTITY frac12  "&#189;" >
<!ENTITY frac34  "&#190;" >
<!ENTITY iquest  "&#191;" >
<!ENTITY Agrave  "&#192;" >
<!ENTITY Aacute  "&#193;" >
<!ENTITY Acirc   "&#194;" >
<!ENTITY Atilde  "&#195;" >
<!ENTITY Auml    "&#196;" >
<!ENTITY Aring   "&#197;" >
<!ENTITY AElig   "&#198;" >
<!ENTITY Ccedil  "&#199;" >
<!ENTITY Egrave  "&#200;" >
<!ENTITY Eacute  "&#201;" >
<!ENTITY Ecirc   "&#202;" >
<!ENTITY Euml    "&#203;" >
<!ENTITY Igrave  "&#204;" >
<!ENTITY Iacute  "&#205;" >
<!ENTITY Icirc   "&#206;" >
<!ENTITY Iuml    "&#207;" >
<!ENTITY ETH     "&#208;" >
<!ENTITY Ntilde  "&#209;" >
<!ENTITY Ograve  "&#210;" >
<!ENTITY Oacute  "&#211;" >
<!ENTITY Ocirc   "&#212;" >
<!ENTITY Otilde  "&#213;" >
<!ENTITY Ouml    "&#214;" >
<!ENTITY times   "&#215;" >
<!ENTITY Oslash  "&#216;" >
<!ENTITY Ugrave  "&#217;" >
<!ENTITY Uacute  "&#218;" >
<!ENTITY Ucirc   "&#219;" >
<!ENTITY Uuml    "&#220;" >
<!ENTITY Yacute  "&#221;" >
<!ENTITY THORN   "&#222;" >
<!ENTITY szlig   "&#223;" >
<!ENTITY agrave  "&#224;" >
<!ENTITY aacute  "&#225;" >
<!ENTITY acirc   "&#226;" >
<!ENTITY atilde  "&#227;" >
<!ENTITY auml    "&#228;" >
<!ENTITY aring   "&#229;" >
<!ENTITY aelig   "&#230;" >
<!ENTITY ccedil  "&#231;" >
<!ENTITY egrave  "&#232;" >
<!ENTITY eacute  "&#233;" >
<!ENTITY ecirc   "&#234;" >
<!ENTITY euml    "&#235;" >
<!ENTITY igrave  "&#236;" >
<!ENTITY iacute  "&#237;" >
<!ENTITY icirc   "&#238;" >
<!ENTITY iuml    "&#239;" >
<!ENTITY eth     "&#240;" >
<!ENTITY ntilde  "&#241;" >
<!ENTITY ograve  "&#242;" >
<!ENTITY oacute  "&#243;" >
<!ENTITY ocirc   "&#244;" >
<!ENTITY otilde  "&#245;" >
<!ENTITY ouml    "&#246;" >
<!ENTITY divide  "&#247;" >
<!ENTITY oslash  "&#248;" >
<!ENTITY ugrave  "&#249;" >
<!ENTITY uacute  "&#250;" >
<!ENTITY ucirc   "&#251;" >
<!ENTITY uuml    "&#252;" >
<!ENTITY yacute  "&#253;" >
<!ENTITY thorn   "&#254;" >
<!ENTITY yuml    "&#255;" >

]>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
<xsl:output method="html" version="1.0"  indent="yes"/>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="/">

	<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
		<title>
			<xsl:text disable-output-escaping="yes">#%lblQANav%# - #%lblProbRep%# '</xsl:text>
			<xsl:value-of disable-output-escaping="yes" select="ProbReport/@Title"/>
			<xsl:text disable-output-escaping="yes">'</xsl:text>
		</title>
	
		<link rel="stylesheet" type="text/css" href="QNXSLStyle.css"/>
		<link href="favicon.ico" rel="shortcut icon"/>

<script type="text/javascript" src="incl/SevClsCalc.js"></script>

<script type="text/javascript">
<xsl:comment>
// dummy: required! Do not remove!
</xsl:comment>
</script>

		<xsl:apply-templates select="ProbReport/Script"/>
	</head>
	<body bgcolor="silver" class="work">
		<xsl:apply-templates select="ProbReport"/>
	</body>
	</html>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="Script">
	<script type="text/javascript">
	<xsl:value-of disable-output-escaping="yes" select="text()"/>
	</script>
</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ProbReport">

	<h2 style="margin-left=6px;">#%lblProbRep%#</h2>

	<table width="98%">
		<tr>
			<td><b>#%lblTicket%#</b></td>
			<td><b><xsl:value-of select="./@Ticket" /></b></td>
			<td><b>UID</b></td>
			<td><xsl:value-of select="./@UID" /></td>
		</tr>

		<tr>
			<td><b>#%lblAuthor%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Author" /></td>
			<td><b>#%lblDate%#</b></td>
			<td><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
		</tr>

		<tr>
			<td><b>#%lblSrc%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@PSource" /></td>
			<td><b>#%lblExtID%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@ExtID" /></td>
		</tr>

		<tr>
			<td width="120px"><b>#%lblTitle%#</b></td>
			<td colspan="3"><xsl:value-of disable-output-escaping="yes" select="./@Title" /></td>
		</tr>
	</table>
		
	<xsl:if test="string(./@Lock)">
		<table><tr><td width="30"><img src="rsc/PadLock.jpg" alt="Locked"/></td></tr></table>
	</xsl:if>

	<table>
		<tr><td width="120px"><b>#%lblProbStat%#</b></td><td>
			<xsl:apply-templates select="./@ProbStat"/>
		</td></tr>
		<tr><td width="120px"><b>#%lblPrio%#</b></td><td>
			<xsl:apply-templates select="./@Prio"/>
		</td></tr>
		<tr><td width="120px"><b>#%lblAssgnTo%#</b></td><td>
			<xsl:apply-templates select="./@Assignd"/>
		</td></tr>
		<tr><td width="120px"><b>#%lblEstFixDate%#</b></td><td>
			<xsl:apply-templates select="./@EstDate"/>
		</td></tr>
	</table>

	<table>
		<tr>
			<td width="120px"><b>#%lblAppl%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Appl" /></td><td width="80px"><b>#%lblRel%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@SoftRel" /></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblFctn%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Fctn" /></td>
			<td width="120px"><b>#%lblSys%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@ExSys" /></td>
		</tr>
		<tr>
			<td width="120px"><b>#%lblUseCase%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@UseCase" /></td>
			<td width="120px"><b>#%lblUCSection%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@UCSection" /></td>			
		</tr>			
	</table>

	<table>
		<!-- tr><td><xsl:value-of disable-output-escaping="yes" select="./@ProbCode" /></td></tr -->
		<xsl:choose>
			<xsl:when test = "substring(./@ProbCode,7,1) = 'F'" >
			
				<tr><td> - #%lblNewFeature%# - </td></tr>
			</xsl:when> 
			<xsl:otherwise> 
	
				<tr><td width="140px"><b>#%lblApplStat%#</b></td><td>
					<xsl:call-template name="ApplStat"/>
				</td></tr>
		
				<tr><td width="140px"><b>#%lblDataStat%#</b></td><td>
					<xsl:call-template name="DataStat"/>
				</td></tr>
		
				<tr><td width="140px"><b>#%lblReprobl%#</b></td><td>
					<xsl:call-template name="Repro"/>
				</td></tr>
		
				<tr><td width="140px"><b>#%lblProbCode%#</b></td><td>
					<xsl:call-template name="ProbCode"/>
				</td></tr>
		
				<tr><td width="140px"><b>#%lblErrMsgI%#</b></td><td>
					<xsl:call-template name="ErrMsg"/>
				</td></tr>
		
				<tr><td width="140px"><b>#%lblWorkAround%#</b></td><td>
					<xsl:call-template name="WorkA"/>
				</td></tr>
		
				<tr><td width="140px"><b>#%lblSevClass%#</b></td><td>
					<script type="text/javascript">
						<xsl:comment>
							var pc = calcSevCls( "<xsl:value-of select="./@ProbCode" />" )
							switch( pc ) {
								case '1': document.writeln("#%valPClass_1%#"); break;
								case '2': document.writeln("#%valPClass_2%#"); break;
								case '3': document.writeln("#%valPClass_3%#"); break;
								case '4': document.writeln("#%valPClass_4%#"); break;
								default: document.writeln( pc ); break;
							}			
						</xsl:comment>
					</script>
				</td></tr>
			</xsl:otherwise> 
		</xsl:choose> 			
	</table>
	
	
	<table>
		<tr>
			<td width="120px">
				<b>#%lblCRPR%#</b>
				<xsl:choose> 
					<xsl:when test = "./@IsCR = 'y'" > 
						<input type="checkbox" checked="true" readonly="true"/>
					</xsl:when>
					<xsl:otherwise> 
						<input type="checkbox" readonly="true"/>
					</xsl:otherwise> 
				</xsl:choose> 			
			</td>
			<td width="80px"><b>#%lblNumber%#</b></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@CRNum" /></td>
		</tr>
	</table>

<!-- Branch:TCom PSys -->
	<xsl:apply-templates select="./PSys"/>

	<xsl:apply-templates select="./RefTCEx"/>

	<xsl:apply-templates select="./SysConfigRef"/>

	<table width="98%">

		<xsl:if test="./WDYD">

			<tr><td><b>#%lblWDYDQ%#</b></td></tr>
			<tr><td colspan="3">
				<xsl:call-template name="br-replace">
					<xsl:with-param name="word" select="./WDYD"/>
				</xsl:call-template>
			</td></tr>
		</xsl:if>

		<xsl:if test="./Expctd">
			<tr><td><b>#%lblWDYEQ%#</b></td></tr>
			<tr><td colspan="3">
				<xsl:call-template name="br-replace">
					<xsl:with-param name="word" select="./Expctd"/>
				</xsl:call-template>
			</td></tr>
		</xsl:if>

		<tr><td><b>#%lblObsrvQ%#</b></td></tr>
		<tr><td colspan="3">
			<xsl:call-template name="br-replace">
				<xsl:with-param name="word" select="./Observ"/>
			</xsl:call-template>
		</td></tr>

		<xsl:if test="./ExtTxt">
			<tr><td><b>#%lblExtTxt%#</b></td></tr>
			<tr><td colspan="3">
				<xsl:call-template name="br-replace">
					<xsl:with-param name="word" select="./ExtTxt"/>
				</xsl:call-template>
			</td></tr>
		</xsl:if>
	</table>

	<xsl:if test="FileUpload">

		<table border="2" cellspacing="0" cellpadding="4" width="98%">
			<tr>
				<td valign="center" align="left" colspan="2">

					<p>#%lblAddData%#</p>
				</td>
			</tr>
			<xsl:apply-templates select="./FileUpload">
				<xsl:sort select="@DateTime" order="descending"/>
			</xsl:apply-templates>			
		</table>
	</xsl:if>
	
	<table width="98%">
		<tr>
			<td colspan="3"><b>#%lblFix%#</b></td>
		</tr>
			<xsl:apply-templates select="./RefFix"/>
		</table>

	<xsl:if test="LogEntry">

		<h4 style="margin-left=6px;">#%lblLogEntries%#</h4>
		<xsl:apply-templates select="./LogEntry">
			<xsl:sort select="@DateTime" order="descending"/>
		</xsl:apply-templates>
	</xsl:if>

	<xsl:if test="ProcLog">

		<h4 style="margin-left=6px;">#%lblProcLog%#</h4>
			<table width="98%">
				<tr><td class="DT"><b>#%lblDate%#</b></td><td>&#160;</td></tr>
				<xsl:apply-templates select="./ProcLog">
					<xsl:sort select="@DateTime" order="descending"/>
				</xsl:apply-templates>
			</table>
	</xsl:if>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="@FixStat">

	<xsl:choose > 
		<xsl:when test = ". = 'as'" > 
			<xsl:text>#%valStat_as%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'nr'" > 
			<xsl:text>#%valStat_rr%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'dr'" > 
			<xsl:text>#%valStat_dr%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'du'" > 
			<xsl:text>#%valStat_du%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'fd'" > 
			<xsl:text>#%valStat_fd%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'fx'" > 
			<xsl:text>#%valStat_fx%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'wf'" > 
			<xsl:text>#%valStat_wf%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rt'" > 
			<xsl:text>#%valStat_rt%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'at'" > 
			<xsl:text>#%valStat_at%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'ps'" ><xsl:text>#%valStat_ps%#</xsl:text></xsl:when>		
		<xsl:when test = ". = 'ts'" > 
			<xsl:text>#%valStat_ts%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'tf'" > 
			<xsl:text>#%valStat_tf%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rj'" > 
			<xsl:text>#%valStat_rj%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rr'" > 
			<xsl:text>#%valStat_rr%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rs'" > 
			<xsl:text>#%valStat_rs%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'rv'" > 
			<xsl:text>#%valStat_rv%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = 'sh'" > 
			<xsl:text>#%valStat_sh%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = ". = 'cl'" > 
			<xsl:text>#%valStat_cl%#</xsl:text> 
		</xsl:when> 
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="." />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="@ProbStat">

	<xsl:choose > 
<xsl:when test = ". = 'as'" ><xsl:text>#%valStat_as%#</xsl:text></xsl:when>
<xsl:when test = ". = 'at'" ><xsl:text>#%valStat_at%#</xsl:text></xsl:when>
<xsl:when test = ". = 'bd'" ><xsl:text>#%valStat_bd%#</xsl:text></xsl:when>
<xsl:when test = ". = 'CfNR'" ><xsl:text>#%valStat_CfNR%#</xsl:text></xsl:when>
<xsl:when test = ". = 'cl'" ><xsl:text>#%valStat_cl%#</xsl:text></xsl:when>
<xsl:when test = ". = 'cr'" ><xsl:text>#%valStat_cr%#</xsl:text></xsl:when>
<xsl:when test = ". = 'ct'" ><xsl:text>#%valStat_ct%#</xsl:text></xsl:when>
<xsl:when test = ". = 'dr'" ><xsl:text>#%valStat_dr%#</xsl:text></xsl:when>
<xsl:when test = ". = 'du'" ><xsl:text>#%valStat_du%#</xsl:text></xsl:when>
<xsl:when test = ". = 'es'" ><xsl:text>#%valStat_es%#</xsl:text></xsl:when>
<xsl:when test = ". = 'ev'" ><xsl:text>#%valStat_ev%#</xsl:text></xsl:when>
<xsl:when test = ". = 'fd'" ><xsl:text>#%valStat_fd%#</xsl:text></xsl:when>
<xsl:when test = ". = 'fx'" ><xsl:text>#%valStat_fx%#</xsl:text></xsl:when>
<xsl:when test = ". = 'nr'" ><xsl:text>#%valStat_nr%#</xsl:text></xsl:when>
<xsl:when test = ". = 'ps'" ><xsl:text>#%valStat_ps%#</xsl:text></xsl:when>
<xsl:when test = ". = 'rCfNR'" ><xsl:text>#%valStat_rCfNR%#</xsl:text></xsl:when>
<xsl:when test = ". = 're'" ><xsl:text>#%valStat_re%#</xsl:text></xsl:when>
<xsl:when test = ". = 'rg'" ><xsl:text>#%valStat_rg%#</xsl:text></xsl:when>
<xsl:when test = ". = 'rj'" ><xsl:text>#%valStat_rj%#</xsl:text></xsl:when>
<xsl:when test = ". = 'rr'" ><xsl:text>#%valStat_rr%#</xsl:text></xsl:when>
<xsl:when test = ". = 'rs'" ><xsl:text>#%valStat_rs%#</xsl:text></xsl:when>
<xsl:when test = ". = 'rt'" ><xsl:text>#%valStat_rt%#</xsl:text></xsl:when>
<xsl:when test = ". = 'rv'" ><xsl:text>#%valStat_rv%#</xsl:text></xsl:when>
<xsl:when test = ". = 'sb'" ><xsl:text>#%valStat_sb%#</xsl:text></xsl:when>
<xsl:when test = ". = 'sh'" ><xsl:text>#%valStat_sh%#</xsl:text></xsl:when>
<xsl:when test = ". = 'tf'" ><xsl:text>#%valStat_tf%#</xsl:text></xsl:when>
<xsl:when test = ". = 'ts'" ><xsl:text>#%valStat_ts%#</xsl:text></xsl:when>
<xsl:when test = ". = 'wf'" ><xsl:text>#%valStat_wf%#</xsl:text></xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="." />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="@Prio">

	<xsl:choose > 
		<xsl:when test = ". = '1'" > 
			<xsl:text>#%valPrio_1%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = '2'" > 
			<xsl:text>#%valPrio_2%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = '3'" > 
			<xsl:text>#%valPrio_3%#</xsl:text> 
		</xsl:when>
		<xsl:when test = ". = '4'" > 
			<xsl:text>#%valPrio_4%#</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="." />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>		

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="ApplStat">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,1,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'C'" > 
			<xsl:text>#%lblCont%#</xsl:text>
		</xsl:when> 
		<xsl:when test = "$subCode = 'I'" > 
			<xsl:text>#%lblInacc%#</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'S'" > 
			<xsl:text>#%lblStpd%#</xsl:text> 
		</xsl:when>
		<xsl:when test = "$subCode = 'R'" >
			<xsl:text>#%lblScrambled%#</xsl:text> 
		</xsl:when>
		<xsl:when test = "$subCode = 'T'" >
			<xsl:text>#%lblStuck%#</xsl:text> 
		</xsl:when>
		<xsl:when test = "$subCode = 'X'" >
			<xsl:text>#%lblCrash%#</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>


<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="DataStat">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,2,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'M'" > 
			<xsl:text>#%lblMinDatLoss%#</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'L'" > 
			<xsl:text>#%lblMajDatLoss%#</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'N'" > 
			<xsl:text>#%lblNoLoss%#</xsl:text> 
		</xsl:when>
		<xsl:when test = "$subCode = 'U'" > 
			<xsl:text>#%lblUndec%#</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="Repro">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,3,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'R'" > 
			<xsl:text>#%lblYes%#</xsl:text> 
		</xsl:when> 
		<xsl:when test = "$subCode = 'X'" > 
			<xsl:text>#%lblNo%#</xsl:text> 
		</xsl:when>
		<xsl:when test = "$subCode = 'N'" > 
			<xsl:text>#%lblNotTested%#</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="ProbCode">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,4,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'I'" > 
			<xsl:text>#%lblIgnorable%#</xsl:text>
		</xsl:when> 
		<xsl:when test = "$subCode = 'A'" > 
			<xsl:text>#%lblAnnoy%#</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'E'" > 
			<xsl:text>#%lblErrorneous%#</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'O'" > 
			<xsl:text>#%lblObstructive%#</xsl:text>
		</xsl:when>
		<xsl:when test = "$subCode = 'B'" > 
			<xsl:text>#%lblBlocked%#</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="ErrMsg">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,5,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'E'" > 
			<xsl:text>#%lblYes%#</xsl:text> 
		</xsl:when>
		<xsl:when test = "$subCode = 'n'" > 
			<xsl:text>#%lblNo%#</xsl:text>
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="WorkA">

	<xsl:variable name="subCode">
		<xsl:value-of select="substring(./@ProbCode,6,1)" />
	</xsl:variable>

	<xsl:choose > 
		<xsl:when test = "$subCode = 'W'" > 
			<xsl:text>#%lblYes%#</xsl:text>
<script type="text/javascript"><xsl:comment>
g_WA = true;
</xsl:comment></script>
		</xsl:when>
		<xsl:when test = "$subCode = 'n'" > 
			<xsl:text>#%lblNo%#</xsl:text> 
		</xsl:when>
		<xsl:otherwise> 
			<xsl:value-of disable-output-escaping="yes" select="$subCode" />
		</xsl:otherwise> 
	</xsl:choose> 

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="RefTCEx">

	<table width="98%">
		<tr>
			<td width="140px"><b>#%lblTCExec%#</b></td>
		</tr>
		<tr><td>
			<xsl:if test="string(./@RefUID)">
				<a href="VQANavDoc?QNA=ViewTCEx&amp;UID={@RefUID}" >
					<xsl:value-of select="./@Title"/>
				</a>
			</xsl:if>
		</td></tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="SysConfigRef">

	<table width="98%">
		<tr>
			<td width="140px"><b>#%lblSysConfig%#</b></td>
		</tr>
		<tr>
			<td>
				<p><xsl:value-of disable-output-escaping="yes" select="./@Title"/></p>
				<p><xsl:value-of disable-output-escaping="yes" select="."/></p>
			</td>
		</tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="RefFix">

		<tr>
			<td width="80px">
				<xsl:apply-templates select="./@FixStat"/>
			</td>
			<td width="140px">
				<xsl:apply-templates select="./@ShipRel"/>
			</td>
			<td>
				<!-- a href="VQANavDoc?QNA=ViewFix&amp;UID={@RefUID}" -->
				<a href="VFixFr.jsp?QNA=ViewFix&amp;UID={@RefUID}" target="_parent">
					<xsl:value-of disable-output-escaping="yes" select="./@Title"/>
				</a>
			</td>
		</tr>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="LogEntry">

	<table width="98%">
		<tr>
			<td class="DT" rowspan="2"><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
			<td width="160px">#%lblAuthor%#: <xsl:value-of disable-output-escaping="yes" select="./@Author"/></td>
			<td><xsl:value-of disable-output-escaping="yes" select="./@Title"/></td>
		</tr>
		<tr>
			<td colspan="2">
				<p>
					<xsl:call-template name="br-replace">
						<xsl:with-param name="word" select="."/>
					</xsl:call-template>
				</p>
			</td>
		</tr>
	</table>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="ProcLog">

		<tr>
			<td class="DT"><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
			<td><p><xsl:value-of disable-output-escaping="yes" select="."/></p></td>
		</tr>

</xsl:template>

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template match="FileUpload">

	<tr><td>
		<table border="1" cellspacing="0" cellpadding="4">
			<tr>
				<td class="DT"><xsl:value-of select="substring-before( ./@DateTime, 'T' )"/>&#160;<xsl:value-of select="substring-after( ./@DateTime, 'T' )"/></td>
				<td width="80px"><xsl:value-of disable-output-escaping="yes" select="./@Author"/></td>
				<td valign="center" align="left" width="550pt">
					<xsl:value-of disable-output-escaping="yes" select="./Desc"/>&#160;
					<a href="Upload/{@UID}/{@TName}" type="{@ContentType}" target="_blank"><xsl:value-of disable-output-escaping="yes" select="./@Name"/></a>
					<!-- br></br>
					<input class="ro" type="text" size="82" value="{Desc}" readonly="true" /-->
				</td>
			</tr>
		</table>
	</td></tr>
</xsl:template>

<!-- Branch:TCom PSys #################### -->

<xsl:template match="PSys">

	<xsl:if test="string(./@PSystem)">
		<tr><td>
			<table width="98%">
				<tr>
					<td width="140px"><b>#%lblPSys%#</b></td>
					<td><xsl:value-of disable-output-escaping="yes" select="./@PSystem"/></td>
					<td width="80px"><b>#%lblVer%#</b></td>
					<td><xsl:value-of disable-output-escaping="yes" select="./@Version"/></td>
					<td width="80px"><b>#%lblOriginator%#</b></td>
					<td><xsl:value-of disable-output-escaping="yes" select="./@Origin"/></td>
				</tr>
			</table>
		</td></tr>
	</xsl:if>
</xsl:template>

<!-- Branch:TCom PSys End -->

<!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
<xsl:template name="br-replace">

	<xsl:param name="word"/>

	<!-- </xsl:text> on next line on purpose to get newline -->
  <xsl:variable name="cr"><xsl:text>
</xsl:text></xsl:variable>

	<xsl:choose>

		<xsl:when test="contains($word,$cr)">

			<xsl:value-of disable-output-escaping="yes" select="substring-before($word,$cr)"/>
			<br/>
			<xsl:call-template name="br-replace">

				<xsl:with-param name="word">

					<xsl:value-of select="substring-after($word,$cr)"/>
			  </xsl:with-param>
			</xsl:call-template>
		</xsl:when>

		<xsl:otherwise>

			<xsl:value-of disable-output-escaping="yes" select="$word"/>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>


</xsl:stylesheet>

